/*
 * Some routines for ROMEO written in "C" :
 * sec100(time) - time counter
 *      Returns the elapsed execution time for this process in 1/100 sec.
 *      calling sequence:
 *      	integer*4 time
 * 	        call sec100 (time)
 * call datymd(id) - returns current date in form: YYYYMMDD (integer*4)
 *
 * ia=locf(arg) - "where I am"
 *      Returns an integer*4 adress of argument
 */

#include <sys/types.h>
#include <sys/times.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/mtio.h>

long sec100_(time) 
long *time;
{	
	struct tms clock;
	times(&clock);
	*time = (clock.tms_utime + clock.tms_stime)* 100/CLK_TCK ;
	return(*time);
}

long datymd_(id)
long *id;
{ struct tm *tp;
  time_t tloc = time(0);
  tp = localtime(&tloc);
  *id = (tp->tm_year) * 10000;
  *id += (tp->tm_mon +1 ) * 100;
  *id += tp->tm_mday;
  return(*id);
}

long locf_(arg)
char *arg;
{ return ( (unsigned) arg / 4 ); }
/*
 *
 *  n = mtrew(lun)       - open read access to tape (if lun<=0)
 *                         then rewind tape.  Result = logical number or -1
 *  n = mtread(lun,buf)  - read physical block from tape lun
 *                         Result = 0  if   E O F
 *                                > 0  bytes read counter
 *                                < 0  error
 */
long mtrew_(ntap)
long *ntap;
{ struct mtop mtdb;
  long t=*ntap;
  if (t<=0)  t=open("/dev/rmt12",O_RDONLY);   /* eb0nr */
  if (t>0)  { mtdb.mt_op=MTREW; if (ioctl(t,MTIOCTOP,&mtdb)==-1) t=-1;}
  return(t); }

long mtfsf_(ntap)
long *ntap;
{ struct mtop mtdb;
  mtdb.mt_op=MTFSF;
  mtdb.mt_count=1; 
  return(ioctl(*ntap,MTIOCTOP,&mtdb)); }

long mtbsr_(ntap)
long *ntap;
{ struct mtop mtdb;
  mtdb.mt_op=MTBSR;
  mtdb.mt_count=1;
  return(ioctl(*ntap,MTIOCTOP,&mtdb)); }

long mtread_(ntap,buf)
long *ntap;
char *buf;
{ long t=*ntap;
  return(read(t,buf,65535));
 }


