      integer*8 function KBINOM(N,K)
      implicit real*8(A-H,O-Z)
      implicit integer*8(I-N)

      IF(N .GE. 0) THEN
       N1=N
       IS=1
      ELSE
       N1=K-N-1
       IS=(-1)**K
      ENDIF
      IF(K .LT. 0 .OR. K .GT. N1) THEN
       IH=0
      ELSEIF(K .EQ. 0 .OR. K .EQ. N1) THEN
       IH=IS
      ELSE
       IF(K+K .LE. N1) THEN
        K1=K
       ELSE
        K1=N1-K
       ENDIF
       H=N1
       A=H
       DO 2 I = 2,K1
       A=A-1
    2  H=H*(A/I)
       IF(H .LE. 1.0e19) THEN
        IH=IS*NINT(H)
       ELSE
        IH=0
        WRITE(*,*) ' KBINOM:integer overflow.  N,K=',N,K
       ENDIF
      ENDIF
      KBINOM=IH
      RETURN
      END

      function afromi(i)
      real*8 r
      character*8 c
      equivalence(c,r)
      c='        '
      c(1:1)=char(ichar('0')+i)
      afromi=r
      return
      end
      function ifroma(a)
      real*8 r
      character*8 c
      equivalence(c,r)
      r=a
      ifroma=ichar(c(1:1))-ichar('0')
      return
      end

      SUBROUTINE CBYT (M,LM,IX,LX,NB)
C
C CERN PROGLIB# M421    CBYT            .VERSION KERNFOR  4.23  891215
C ORIG. 14/08/70 CL
C
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      PARAMETER   (NBITPW=64)
      PARAMETER   (IALL11 = -1)
      IX = IOR ( IAND (IX,
     +                  NOT(ISHFT (ISHFT(IALL11,-NBITPW+NB), LX-1)))
     +,   ISHFT (ISHFT(ISHFT(M,-LM+1),NBITPW-NB), -NBITPW-1+LX+NB))
      RETURN
      END

      function jbyt(izw,izp,nzb)
      implicit integer*8(I-N)
      parameter(nbitpw=64)
      jbyt=ishft(ishft(izw,nbitpw+1-izp-nzb),-nbitpw+nzb)
      return
      end

      SUBROUTINE SBYT (IT,IZW,IZP,NZB)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      PARAMETER   (NBITPW=64)
      PARAMETER   (IALL11 = -1)
      MSK = ISHFT  (IALL11,-NBITPW+NZB)
      IZW = IOR ( IAND (IZW, NOT(ISHFT (MSK,IZP-1)))
     +,           ISHFT (IAND(IT,MSK),IZP-1))
      RETURN
      END
      FUNCTION ATG (RSINA,RCOSA)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
C
C CERN PROGLIB# B101    ATG             .VERSION KERNFOR  4.21  890323
C ORIG. 15/11/66 JZ, re-write 8/03/89 K.S.Koelbig
C
      PARAMETER (PI = 3.14159 26535 89793)

      ATG = ATAN2(RSINA,RCOSA) + (PI-SIGN(PI,RSINA))
      RETURN
      END
      FUNCTION PROB (CHI2,N)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      DATA SRTOPI /0.79788456080287/
      DATA UPL /1300./
C+SELF,  IF=NUME75.
C      DATA UPL /340./
C+SELF,  IF=NUME38.
C      DATA UPL /170./
      PROB=0.
      IF (N .LE. 0 .OR. CHI2 .LT. 0.) RETURN
      IF (N .GT. 100) GO TO 30
      IF (CHI2 .GT. UPL)  RETURN
      EMYO2=EXP(-0.5*CHI2)
      SUM=1.
      TERM=1.
      M=N/2
      IF (2*M .NE. N) GO TO 1
C--                ENTRY IF N IS EVEN
      IF (M .EQ. 1) GO TO 11
      DO 10 I=2,M
      FI=I-1
      TERM=0.5*TERM*CHI2/FI
   10 SUM=SUM+TERM
   11 PROB=EMYO2*SUM
      RETURN
C--                ENTRY IF N IS ODD
    1 SRTY=SQRT (CHI2)
      VALUE=2.*(1.-FREQ (SRTY))
      IF (N .NE. 1) GO TO 2
      PROB=VALUE
      RETURN
    2 CONST=SRTOPI*SRTY*EMYO2
      IF (N .EQ. 3) GO TO 21
      K=M-1
      DO 20 I=1,K
      FI =I
      TERM=TERM*CHI2/(2.*FI+1.)
   20 SUM=SUM+TERM
   21 PROB=CONST*SUM+VALUE
      RETURN
C--                USE ASYMPTOTIC FORMULA
   30 ANU=1./FLOAT(N)
      AN9=ANU/4.5
      XP=1./3.
      Z=((CHI2*ANU)**XP - (1.-AN9)) / SQRT (AN9)
      PROB=1. - FREQ (Z)
      RETURN
      END
      FUNCTION FREQ (X)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
C
C CERN PROGLIB# C300    FREQ            .VERSION KERNFOR  3.16  820125
C ORIG. 10/08/76 G.ERSKINE
C
C     DERIVED FROM D=ERF IN P=TCGEN WITH ERF/ERFC REMOVED.
C     20/05/80 JZ
C
C     ******************************************************************
C
C     FOR ABS(X) LE 0.47 THE BASIC FUNCTION IS ERF.  FOR ABS(X) GT 0.47
C     THE BASIC FUNCTION IS ERFC.  THE FINAL RESULT IS OBTAINED IN TERMS
C     OF THE BASIC FUNCTION AS SHOWN IN THE FOLLOWING TABLE.  A=ABS(X)
C     AND C=SQRT(2).
C
C       FUNCTION     A.LE.(0.47)                   A.GT.(0.47)
C       REQUIRED       (ALL X)          (NEGATIVE X)       (POSITIVE X)
C
C       ERF(X)         ERF(X)             ERFC(A)-1          1-ERFC(X)
C
C       ERFC(X)       1-ERF(X)            2-ERFC(A)           ERFC(X)
C
C       FREQ(X)   0.5+0.5*ERF(X/C)      0.5*ERFC(A/C)    1-0.5*ERFC(X/C)
C
C     ******************************************************************
C
      DATA CONST1/ 0.70710 67811 86548 /
C        ( CONST1= SQRT(1/2) )
C
C
      T = CONST1*X
      IF (X.GE.0.)           GO TO 31
C
C--                -VE ARGUMENT
C
      IF (X.GE.-.47)         GO TO 34
      FREQ = .5 * ERFC(-T)
      RETURN
C
C--                POSITIVE ARGUMENT
C
   31 IF (X.GT.6.0)          GO TO 38
      IF (X.GE.0.47)         GO TO 36
   34 FREQ = .5 + .5 * ERF(T)
      RETURN
C
   36 FREQ = 1. - .5 * ERFC(T)
      RETURN
C
   38 FREQ = 1.
      RETURN
      END
      FUNCTION ERF (X)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
C
C CERN PROGLIB# C300    ERF             .VERSION KERNFOR  3.15  820113
C ORIG. 10/08/76 G.ERSKINE
C
C     ******************************************************************
C
C     ENTRY POINTS ... ERF, ERFC.
C
C     THESE THREE FUNCTIONS ARE COMPUTED FROM THE RATIONAL APPROXIMAT-
C     IONS OF W.J.CODY, MATHEMATICS OF COMPUTATION, VOLUME 22 (1969),
C     PAGES 631-637.
C
C     FOR ABS(X) LE 0.47 THE BASIC FUNCTION IS ERF.  FOR ABS(X) GT 0.47
C     THE BASIC FUNCTION IS ERFC.  THE FINAL RESULT IS OBTAINED IN TERMS
C     OF THE BASIC FUNCTION AS SHOWN IN THE FOLLOWING TABLE.  A=ABS(X)
C     AND C=SQRT(2).
C
C       FUNCTION     A.LE.(0.47)                   A.GT.(0.47)
C       REQUIRED       (ALL X)          (NEGATIVE X)       (POSITIVE X)
C
C       ERF(X)         ERF(X)             ERFC(A)-1          1-ERFC(X)
C
C       ERFC(X)       1-ERF(X)            2-ERFC(A)           ERFC(X)
C
C     ******************************************************************
C
      DIMENSION P1(4),Q1(4), P2(8),Q2(8), P3(5),Q3(5)
      DATA P1/2.42667 95523 0532 D2,
     1        2.19792 61618 2942 D1,
     2        6.99638 34886 1914 D0,
     3       -3.56098 43701 8154 D-2/
      DATA Q1/2.15058 87586 9861 D2,
     1        9.11649 05404 5149 D1,
     2        1.50827 97630 4078 D1,
     3        1.00000 00000 0000 D0/
      DATA P2/3.00459 26102 0162 D2,
     1        4.51918 95371 1873 D2,
     2        3.39320 81673 4344 D2,
     3        1.52989 28504 6940 D2,
     4        4.31622 27222 0567 D1,
     5        7.21175 82508 8309 D0,
     6        5.64195 51747 8974 D-1,
     7       -1.36864 85738 2717 D-7/
      DATA Q2/3.00459 26095 6983 D2,
     1        7.90950 92532 7898 D2,
     2        9.31354 09485 0610 D2,
     3        6.38980 26446 5631 D2,
     4        2.77585 44474 3988 D2,
     5        7.70001 52935 2295 D1,
     6        1.27827 27319 6294 D1,
     7        1.00000 00000 0000 D0/
      DATA P3/-2.99610 70770 3542 D-3,
     1        -4.94730 91062 3251 D-2,
     2        -2.26956 59353 9687 D-1,
     3        -2.78661 30860 9648 D-1,
     4        -2.23192 45973 4185 D-2/
      DATA Q3/1.06209 23052 8468 D-2,
     1        1.91308 92610 7830 D-1,
     2        1.05167 51070 6793 D0,
     3        1.98733 20181 7135 D0,
     4        1.00000 00000 0000 D0/
      DATA CONST1/ 0.70710 67811 86548 /
C        ( CONST1= SQRT(1/2) )
      DATA CONST2/0.56418 95835 47756 /
C        ( CONST2= SQRT(1/PI) )
C
C     ******************************************************************
C
C  ENTRY POINTS. SET IENTRY (=1 FOR ERF, =2 FOR ERFC).
C
      IENTRY=1
      T=X
      A=ABS(T)
      IF(A.LE.6.0) GO TO 11
      ERF=SIGN(1.0,X)
      RETURN
C
      ENTRY  ERFC (X)
      IENTRY=2
      T=X
      IF(T.GE.-6.0) GO TO 10
      ERFC=2.0
      ERF=2.0
      RETURN
C
C  SELECT BASIC FUNCTION. SET IBASIC (=1 FOR ERF, =2 FOR ERFC).
C
   10 A=ABS(T)
   11 S=T**2
      IF(A.GT.0.47) GO TO 20
C
C  IBASIC=1.  SET Y=ERF(T).
C
      IBASIC=1
      Y=T*(P1(1)+S*(P1(2)+S*(P1(3)+S*P1(4) )))
     1   /(Q1(1)+S*(Q1(2)+S*(Q1(3)+S*Q1(4) )))
      GO TO 30
C
C  IBASIC=2. SET Y=ERFC(A).
C
   20 IBASIC=2
      IF(A.GT.4.0) GO TO 21
      Y=EXP(-S)*(P2(1)+A*(P2(2)+A*(P2(3)+A*(P2(4)+A*(P2(5)+
     1        A*(P2(6)+A*(P2(7)+A*P2(8) )))))))
     2         /(Q2(1)+A*(Q2(2)+A*(Q2(3)+A*(Q2(4)+A*(Q2(5)+
     3        A*(Q2(6)+A*(Q2(7)+A*Q2(8) )))))))
      GO TO 30
C
   21 Y=0.0
      IF(A.GT.26.0) GO TO 30
      R=1.0/A
      U=R**2
      Y=R*EXP(-S)*( CONST2 +
     1     U*(P3(1)+U*(P3(2)+U*(P3(3)+U*(P3(4)+U*P3(5) ))))
     2      /(Q3(1)+U*(Q3(2)+U*(Q3(3)+U*(Q3(4)+U*Q3(5) )))) )
C
C  EXPRESS FINAL RESULT IN TERMS OF Y.
C
   30 IF(IENTRY.NE.1) GO TO 40
      IF(IBASIC.EQ.2) GO TO 31
      ERF=Y
      RETURN
   31 ERF=1.0-Y
      IF(X.LT.0.0) ERF=-ERF
      RETURN
C
   40 IF(IBASIC.EQ.2) GO TO 41
      Y=1.0-Y
      GO TO 42
   41 IF(X.LT.0.0) Y=2.0-Y
   42 ERFC=Y
      ERF=Y
      RETURN
      END
      FUNCTION PROXIM (ANGL,STAND)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
C
C CERN PROGLIB# B102    PROXIM          .VERSION KERNFOR  4.21  890323
C ORIG. 15/03/68 JZ, re-write 8/03/89 K.S.Koelbig
C
      PARAMETER (PI2 = 6.28318 53071 79586D0, RPI2 =1/PI2)

      PROXIM = ANGL + PI2*ANINT(RPI2*(STAND-ANGL))
      RETURN
      END
      SUBROUTINE MXMLRT (A,B,C,NI,NJ)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
C
C CERN PROGLIB# F110    MXMLRT          .VERSION KERNFOR  2.00  720707
C ORIG. 01/01/64 RKB
C
      DIMENSION A(*),B(*),C(*)
C
C--      ENTRY MXMLRT
C
C--                C = A(I,J) X B(J,J) X A*(J,I)
C--                A* STANDS FOR A-TRANSPOSED
C
C        CALL MXMLRT (A,B,C,NI,NJ)     IS EQUIVALENT TO
C             CALL MXMPY (A,B,X,NI,NJ,NJ)
C             CALL MXMPY1 (X,A,C,NI,NJ,NI)
C
C        OR   CALL MXMPY1 (B,A,Y,NJ,NJ,NI)
C             CALL MXMPY (A,Y,C,NI,NJ,NI)
C
      IPA=1
      JPA=NJ
      GO TO 5
C
         ENTRY MXMLTR   (A,B,C,NI,NJ)
C
C--                C = A*(I,J) X B(J,J) X A(J,I)
C
C        CALL MXMLTR (A,B,C,NI,NJ)     IS EQUIVALENT TO
C             CALL MXMPY2 (A,B,X,NI,NJ,NJ)
C             CALL MXMPY (X,A,C,NI,NJ,NI)
C
C        OR   CALL MXMPY (B,A,Y,NJ,NJ,NI)
C             CALL MXMPY2 (A,Y,C,NI,NJ,NI)
C
      IPA=NI
      JPA=1
C
    5 CONTINUE
      IF (NI.LE.0) RETURN
      IF (NJ.LE.0) RETURN
      IC1=1
      IA1=1
         DO 50 II=1,NI
C
      IC=IC1
         DO 10 KC=1,NI
      C(IC)=0.
   10 IC=IC+1
C
      IB1=1
      JA1=1
         DO 40 JJ=1,NJ
C
      IB=IB1
      IA=IA1
      X=0.
         DO 20 KJ=1,NJ
      X=X + A(IA)*B(IB)
      IA=IA+IPA
      IB=IB+NJ
   20 CONTINUE
C
      JA=JA1
      IC=IC1
         DO 30 KI=1,NI
      C(IC)=C(IC) + X*A(JA)
      IC=IC+1
      JA=JA+JPA
   30 CONTINUE
C
      IB1=IB1+1
      JA1=JA1+IPA
   40 CONTINUE
C
      IC1=IC1+NI
      IA1=IA1+JPA
   50 CONTINUE
      RETURN
      END
      SUBROUTINE MXMAD(A,B,C,I,J,K)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
C
C CERN PROGLIB# F110    MXMAD           .VERSION KERNFOR  1.0   650809
C ORIG. 01/01/64 RKB
C
      DIMENSION A(*),B(*),C(*)
C
      IANDJ=21
      GO TO 1
C
         ENTRY MXMAD1  (A,B,C,I,J,K)
C
      IANDJ=22
      GO TO 1
C
         ENTRY MXMAD2  (A,B,C,I,J,K)
C
      IANDJ=23
      GO TO 1
C
         ENTRY MXMAD3  (A,B,C,I,J,K)
C
      IANDJ=24
      GO TO 1
C
         ENTRY MXMPY   (A,B,C,I,J,K)
C
      IANDJ=11
      GO TO 1
C
         ENTRY MXMPY1  (A,B,C,I,J,K)
C
      IANDJ=12
      GO TO 1
C
         ENTRY MXMPY2  (A,B,C,I,J,K)
C
      IANDJ=13
      GO TO 1
C
         ENTRY MXMPY3  (A,B,C,I,J,K)
C
      IANDJ=14
      GO TO 1
C
         ENTRY MXMUB   (A,B,C,I,J,K)
C
      IANDJ=31
      GO TO 1
C
         ENTRY MXMUB1  (A,B,C,I,J,K)
C
      IANDJ=32
      GO TO 1
C
         ENTRY MXMUB2  (A,B,C,I,J,K)
C
      IANDJ=33
      GO TO 1
C
         ENTRY MXMUB3  (A,B,C,I,J,K)
C
      IANDJ=34
C
    1 N1=IANDJ/10
      N2=IANDJ-10*N1
      IF((I.EQ.0).OR.(K.EQ.0)) GO TO 100
      GO TO  (3,3,5,5),N2
C
    3 IIA=1
      IOA=J
      GO TO 7
    5 IIA=I
      IOA=1
    7 GO TO (9,11,9,11),N2
    9 IIB=K
      IOB=1
      GO TO 13
   11 IIB=1
      IOB=J
   13 IA=1
      IC=1
      DO 25 L=1,I
      IB =1
      DO 23 M=1,K
      GO TO (15,18,16),N1
   15 C(IC)=0.
      GO TO 18
   16 C(IC)=-C(IC)
   18 IF (J.EQ.0) GO TO 23
      JA=IA
      JB=IB
      DO 20 N=1,J
      C(IC)=C(IC)+A(JA)*B(JB)
      JA=JA+IIA
   20 JB=JB+IIB
      IB=IB+IOB
   23 IC=IC+1
   25 IA=IA+IOA
  100 RETURN
      END
      SUBROUTINE MXTRP (A,B,I,J)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
C
C CERN PROGLIB# F110    MXTRP           .VERSION KERNFOR  1.0   650809
C ORIG. 01/01/64 RKB
C
      DIMENSION A(*),B(*)
C
C
      IF((I.EQ.0).OR.(J.EQ.0))GO TO 100
      IB=1
      DO 1 K=1,J
      IA=K
      DO 1 L=1,I
      B(IB)=A(IA)
      IA=IA+J
    1 IB=IB+1
  100 RETURN
      END
      SUBROUTINE MXUTY(A,I)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
C
C CERN PROGLIB# F110    MXUTY           .VERSION KERNFOR  1.0   650809
C ORIG. 01/01/64 RKB
C
      DIMENSION   A(*)
C
      IF(I.EQ.0) GO TO 100
      J=1
      IF(I.EQ.1) GO TO 2
      DO 1 K=2,I
      A(J)=1.
      J=J+1
      DO 1 L=1,I
      A(J)=0.
    1 J=J+1
    2 A(J)=1.
  100 RETURN
      END
      SUBROUTINE SMXINV (A,NDIM,IFAIL)
C
C CERN PROGLIB# F107    SMXINV          .VERSION KERNFOR  1.0   720503
C ORIG. 03/05/72 CL
C
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      DIMENSION A(*),INDEX(100),RI(100)
C
      DATA  TOL / 1.E-12/
C
      IFAIL=0
      N=NDIM
      NP1=N+1
         DO 10 I=1,N
   10 INDEX(I)=1
C
         DO 80 I=1,N
C
C--                FIND PIVOT
      PIVOT=0.
      JJ=1
         DO 20 J=1,N
      IF (INDEX(J).EQ.0) GO TO 19
      ELM=ABS (A(JJ))
      IF (ELM.LE.PIVOT) GO TO 19
      PIVOT=ELM
      K=J
      KK=JJ
   19 JJ=JJ+NP1
   20 CONTINUE
      IF (PIVOT/ABS(A(1)).LT.TOL) GO TO 100
      INDEX(K)=0
      PIVOT=-A(KK)
C
C--                ELIMINATION
      KJ=K
      NP=N
C
         DO 70 J=1,N
      IF (J-K) 34,30,34
C
   30 A(KJ)=1./PIVOT
      RI(J)=0.
      NP=1
      GO TO 70
C
   34 ELM=-A(KJ)
   40 RI(J)=ELM/PIVOT
      IF (ELM.EQ.0.) GO TO 50
C
      JL=J
         DO 45 L=1,J
      A(JL)=A(JL)+ELM*RI(L)
   45 JL=JL+N
C
   50 A(KJ)=RI(J)
C
   70 KJ=KJ+NP
C
   80 CONTINUE
C
C--                CHANGE THE SIGN AND PROVISIONAL FILL-UP
      IJ0=1
      JI0=1
         DO 95 I=1,N
      IJ=IJ0
      JI=JI0
C
         DO 90 J=1,I
      A(IJ)=-A(IJ)
      A(JI)=A(IJ)
      IJ=IJ+N
      JI=JI+1
   90 CONTINUE
C
      IJ0=IJ0+1
      JI0=JI0+N
   95 CONTINUE
      RETURN
C
C--                FAILURE RETURN
  100 IFAIL=1
      RETURN
      END
      SUBROUTINE VADD (B,C,A,N)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
C
C CERN PROGLIB# F121    VADD            .VERSION KERNFOR  1.0   710701
C ORIG. 01/07/71
C
      DIMENSION A(*),B(*),C(*)
C
      IF (N.LE.0)  RETURN
      DO 9 I= 1,N
    9 A(I)= B(I) + C(I)
C
      RETURN
      END
      SUBROUTINE  VCOPYN (A,X,N)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
C
C CERN PROGLIB# F121    VCOPYN          .VERSION KERNFOR  3.15  820113
C ORIG. 01/04/73
C
      DIMENSION A(*), X(*)
C
      IF(N.LE.0)  RETURN
      DO 10  I=1,N
   10 X(I)= -A(I)
      RETURN
      END
      SUBROUTINE VMATL (H,A,X,K,N)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
C
C CERN PROGLIB# F121    VMATL           .VERSION KERNFOR  1.0   710701
C ORIG. 01/07/71
C
      DIMENSION A(*),X(*),H(N,K)
C
      IF (N.LE.0)  RETURN
      DO 9 I= 1,K
      X(I)= 0.
      DO 9 J= 1,N
      X(I)= X(I) + A(J)*H(J,I)
    9 CONTINUE
      RETURN
      END
      SUBROUTINE VMATR (A,G,X,N,K)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
C
C CERN PROGLIB# F121    VMATR           .VERSION KERNFOR  1.0   710701
C ORIG. 01/07/71
C
      DIMENSION A(*),X(*),G(K,N)
C
      IF (N.LE.0)  RETURN
      DO 9 I= 1,K
      X(I)= 0.
      DO 9 J= 1,N
    9 X(I)= X(I) + G(I,J)*A(J)
      RETURN
      END
      FUNCTION VMIN (A,N)
C
C CERN PROGLIB# F121    VMIN            .VERSION KERNFOR  1.0   710701
C ORIG. 01/07/71
C
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      DIMENSION A(*)
C
      IF (N.LE.0)  GO TO 100
      FMIN= A(1)
      DO 9 I= 1,N
      FMIN = MIN (A(I),FMIN)
    9 CONTINUE
      VMIN= FMIN
      RETURN
  100 VMIN = 0.
      RETURN
      END
      FUNCTION VMOD (A,N)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
C
C CERN PROGLIB# F121    VMOD            .VERSION KERNFOR  1.0   710701
C ORIG. 01/07/71
C
      DIMENSION A(*)
C
      XX= 0.
      IF (N.LE.0)  GO TO 100
      DO 9 I= 1,N
    9 XX= XX + A(I)*A(I)
      IF (XX.LE.0.)  GO TO 100
      VMOD= SQRT (XX)
      RETURN
  100 VMOD = 0.
      RETURN
      END
      SUBROUTINE VSUB (A,B,X,N)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
C
C CERN PROGLIB# F121    VSUB            .VERSION KERNFOR  1.0   710701
C ORIG. 01/07/71
C
      DIMENSION A(*),B(*),X(*)
C
      IF (N.LE.0)  RETURN
      DO 9 I= 1,N
    9 X(I)= A(I) - B(I)
      RETURN
      END
      SUBROUTINE VSCALE (B,ALPHA,A,N)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
C
C CERN PROGLIB# F121    VSCALE          .VERSION KERNFOR  1.0   710701
C ORIG. 01/07/71
C
      DIMENSION A(*),B(*)
C
      IF (N.LE.0)  RETURN
      DO 9 I= 1,N
    9 A(I)= B(I) * ALPHA
C
      RETURN
      END

      SUBROUTINE UCOPY2(A,B,N)   ! cernlib routine
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      DIMENSION A(*),B(*)
      ENTRY IUCOPY2(A,B,N)
       entry iucopy(a,b,n)
       entry ucopy(a,b,n)
      IF (N.LT.1) GOTO 20
      IA=LOCF(A)
      IB=LOCF(B)
      IF (IA-IB) 10,20,30       ! more safe then in CERN prototype
  10  I=N
  11  B(I)=A(I)
      I=I-1
      IF (I.NE.0) GOTO 11
      GOTO 20
  30  DO 31 I=1,N
  31  B(I)=A(I)
  20  RETURN
      END

      SUBROUTINE UZERO(m,j1,j2)  ! cernlib
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      DIMENSION m(*)
      ENTRY IUZERO(m,j1,j2)
      DO 1 i=j1,j2
  1   m(i)=0
      return
      end

      subroutine vzero(m,n)      ! cernlib
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      dimension m(*)
      ENTRY ivzero(m,n)
      if (n.lt.1) return
      do 1 i=1,n
  1   m(i)=0
      return
      end

      subroutine timezb(it)      ! Time in 0.001 of minute
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      integer*4 stime
      call sec100(stime)    ! sec*100
      it=10*stime/60
      return
      end
      subroutine datezb(id)      ! Date in form YYYYMMDD
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      integer*4 sdat
      call datymd(sdat)
      id=sdat
      return
      end
      FUNCTION IUCOMP (ITEXT,IVECT,N)
C
C CERN PROGLIB# V304    IUCOMP          .VERSION KERNFOR  1.0   710701
C ORIG. 01/01/66 JZ
C
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      DIMENSION IVECT(9)
C
      IF (N.EQ.0) GO TO 18
      DO 12 J=1,N
      IF (ITEXT.EQ.IVECT(J))  GO TO 24
   12 CONTINUE
   18 J=0
C
   24 IUCOMP= J
      RETURN
      END

      subroutine ublow(ms,mt,n)
      character*(*) ms
      character*8 t,mt(2)
      do i=1,n
        t='        '
        t(1:1) = ms(i:i)
        mt(i) = t
      enddo
      return
      end

      subroutine ubunch(ms,mt,n) ! cernlib with n=8 for romeo
c      IMPLICIT REAL*8(A-H,O-Z)
c      IMPLICIT INTEGER*8(I-N)
c      dimension ms(4)
c      mt=0
c      do 1 i=1,n
C  1   mt=ior(ishft(mt,8),iand(ms(n-i+1),255))  ! specially for VAX
c   1   mt=ior(ishft(mt,8),ishft(ms(i),-56))      ! CONVEX
       character*8 t,mt,ms(2)
       mt='        '
       do i=1,n
         t = ms(i)
         mt(i:i) = t(1:1)
       enddo
      return
      end

      subroutine ublank(m,j1,j2)  ! cernlib for 64-bit machine
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      dimension m(*)
      data ibl/8h        /
      do 1 i=j1,j2
  1   m(i)=ibl
      return
      end

      subroutine ufill(m,j1,j2,it)  ! cernlib
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      dimension m(*)
      do 1 i=j1,j2
  1   m(i)=it
      return
      end
      SUBROUTINE UCOCOP(A,B,IDO,IW,NA,NB)
C
C CERN PROGLIB# V302    UCOCOP          .VERSION KERNFOR  4.40  940929
C ORIG. 01/01/70 F.BRUYANT
C
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      DIMENSION A(*),B(*)
C
      IF (IDO.EQ.0) RETURN
      IF (IW.EQ.0) RETURN
      K=0
      L=0
      KK=NA-IW
      LL=NB-IW
      DO 20 I=1,IDO
      DO 10 J=1,IW
      K=K+1
      L=L+1
   10 B(L)=A(K)
      K=K+KK
   20 L=L+LL
      RETURN
      END
      SUBROUTINE UDICOP(A,B,IDO,IW,NA,NB)
C
C CERN PROGLIB# V302    UDICOP          .VERSION KERNFOR  4.40  940929
C ORIG. 01/07/71
C
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      DIMENSION A(*),B(*)
C
      IF (IDO.EQ.0) RETURN
      IF (IW.EQ.0) RETURN
      K=IW+(IDO-1)*NA
      L=IW+(IDO-1)*NB
      KK=NA-IW
      LL=NB-IW
         DO 40 I=1,IDO
         DO 30 J=1,IW
      B(L)=A(K)
      K=K-1
   30 L=L-1
      K=K-KK
   40 L=L-LL
      RETURN
      END

      function doti(x,y)     ! disappear in modern cernlib
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      dimension x(4),y(4)    ! manually taken from listing
      doti=x(1)*y(1)+x(2)*y(2)+x(3)*y(3) - x(4)*y(4)
      return
      end
      function dot(x,y)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      dimension x(4),y(4)
      a=0.
      do 19 i=1,3
  19  a=a+x(i)*y(i)
      dot=a
      return
      end
      function dot4(x,y)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      dimension x(4),y(4)
      a=0.
      do 19 i=1,4
  19  a=a+x(i)*y(i)
      dot4=a
      return
      end
      function vdot(x,y,n)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      dimension x(4),y(4)
      a=0.
      if(n.lt.1) goto 1
      do 19 i=1,n
  19  a=a+x(i)*y(i)
   1  vdot=a
      return
      end
      function vmodul(a)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      dimension a(3)
      vmodul=sqrt(a(1)**2+a(2)**2+a(3)**2)
      return
      end

      SUBROUTINE  MATIN1 (A,IDIM1,N1,IDIM2,N2,INDEX,NERROR,DETERM)
C
C CERN PROGLIB# F100    MATIN1          .VERSION KERNFOR  3.15  820113
C ORIG. 03/05/72 H.V.EIKEN
C
C        MATRIX INVERSION WITH ACCOMPANYING SOLUTION OF LINEAR EQUATIONS
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      DIMENSION A(IDIM1),INDEX(IDIM1)
      DETER=1.0
      N=N1
      IEMAT=N+N2
      IDIM=IDIM1
      NMIN1=N-1
C        THE ROUTINE DOES ITS OWN EVALUATION FOR DOUBLE SUBSCRIPTING OF
C        ARRAY A.
      IPIVC=1-IDIM
C        MAIN LOOP TO INVERT THE MATRIX
      DO 11 MAIN=1,N
      PIVOT=0.0
      IPIVC=IPIVC+IDIM
C        SEARCH FOR NEXT PIVOT IN COLUMN MAIN.
      IPIVC1=IPIVC+MAIN-1
      IPIVC2=IPIVC +NMIN1
      if(ipivc1.le.ipivc2) then
      DO 2 I=IPIVC1,IPIVC2
      IF(ABS(A(I))-ABS(PIVOT)) 2,2,1
    1 PIVOT=A(I)
      LPIV=I
    2 CONTINUE
      endif
C        IS PIVOT DIFFERENT FROM ZERO
      IF(PIVOT) 3,15,3
C        GET THE PIVOT-LINE INDICATOR AND SWAP LINES IF NECESSARY
    3 ICOL=LPIV-IPIVC+1
      INDEX(MAIN)=ICOL
      IF(ICOL-MAIN) 6,6,4
C        COMPLEMENT THE DETERMINANT
    4 DETER=-DETER
C        POINTER TO LINE PIVOT FOUND
      ICOL=ICOL-IDIM
C        POINTER TO EXACT PIVOT LINE
      I3=MAIN-IDIM
      DO 5 I=1,IEMAT
      ICOL=ICOL+IDIM
      I3=I3+IDIM
      SWAP=A(I3)
      A(I3)=A(ICOL)
    5 A(ICOL)=SWAP
C        COMPUTE DETERMINANT
    6 DETER=DETER*PIVOT
      PIVOT=1./PIVOT
C        TRANSFORM PIVOT COLUMN
      I3=IPIVC+NMIN1
      DO 7 I=IPIVC,I3
    7 A(I)=-A(I)*PIVOT
      A(IPIVC1)=PIVOT
C        PIVOT ELEMENT TRANSFORMED
C
C        NOW CONVERT REST OF THE MATRIX
      I1=MAIN-IDIM
C        POINTER TO PIVOT LINE ELEMENTS
      ICOL=1-IDIM
C        GENERAL COLUMN POINTER
      DO 10 I=1,IEMAT
      ICOL=ICOL+IDIM
      I1=I1+IDIM
C        POINTERS MOVED
      IF(I-MAIN) 8,10,8
C        PIVOT COLUMN EXCLUDED
    8 JCOL=ICOL+NMIN1
      SWAP=A(I1)
      I3=IPIVC-1
      DO 9 I2=ICOL,JCOL
      I3=I3+1
    9 A(I2)=A(I2)+SWAP*A(I3)
      A(I1)=SWAP*PIVOT
   10 CONTINUE
   11 CONTINUE
C        NOW REARRANGE THE MATRIX TO GET RIGHT INVERS
      DO 14 I1=1,N
      MAIN=N+1-I1
      LPIV=INDEX(MAIN)
      IF(LPIV-MAIN) 12,14,12
   12 ICOL=(LPIV-1)*IDIM+1
      JCOL=ICOL+NMIN1
      IPIVC=(MAIN-1)*IDIM+1-ICOL
      DO 13 I2=ICOL,JCOL
      I3=I2+IPIVC
      SWAP=A(I2)
      A(I2)=A(I3)
   13 A(I3)=SWAP
   14 CONTINUE
      DETERM=DETER
      NERROR=0
      RETURN
   15 NERROR=MAIN
      DETERM=DETER
      RETURN
      END

      SUBROUTINE MXADD(A,B,C,I,J)
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
C
C
      DIMENSION A(*),B(*),C(*)
C
C
C--                ENTRY MXADD
      N=I*J
      IF(N.EQ.0) GO TO 100
      DO 11 L=1,N
   11 C(L)=A(L)+B(L)
      GO TO 100
C
        ENTRY MXSUB   (A,B,C,I,J)
C
      N=I*J
      IF(N.EQ.0) GO TO 100
      DO 21 L=1,N
   21 C(L)=A(L)-B(L)
      GO TO 100
C
        ENTRY MXTRA   (A,B,C,I,J)
C
      N=I*J
      IF (N.GT.0)  CALL UCOPY (A,C,N)
      GO TO 100
C
        ENTRY MXMTR   (A,B,C,I,J)
C
      N=I*J
      IF(N.EQ.0) GO TO 100
      DO 41 L=1,N
   41 C(L)=B(1)*A(L)
      GO TO 100
C
        ENTRY MXNTR   (A,B,C,I,J)
C
      N=I*J
      IF(N.EQ.0) GO TO 100
      DO 51 L=1,N
   51 C(L)=-A(L)
C
  100 RETURN
      END

      SUBROUTINE MXEQU(A,B,I,J)
C
C CERN PROGLIB# F109    MXEQU           .VERSION KERNFOR  1.0   680220
C ORIG. 01/01/64 RKB ET AL
C
      IMPLICIT REAL*8(A-H,O-Z)
      IMPLICIT INTEGER*8(I-N)
      DIMENSION A(*),B(*)
C
      IF (I.EQ.0) RETURN
C
C--                TRANSFORMATION OF A-MATRIX
   10 LL=1
         DO 17 L=1,I
      DIAG=-1./A(LL)
      LM=L
C
         DO 12 M=1,I
      IF (L.EQ.M) GO TO 12
      A(LM)=A(LM)*DIAG
   12 LM=LM+I
C
      LPLUS1=L+1
      IF (LPLUS1.GT.I) GO TO 20
      L1L=LL+1
C
      if(lplus1.le.i) then
      DO 16 L1=LPLUS1,I
      L1M=L1
      LM=L
C
         DO 15 M=1,I
      IF (L.EQ.M) GO TO 14
      A(L1M)=A(L1M)+A(L1L)*A(LM)
   14 L1M=L1M+I
   15 LM=LM+I
C
   16 L1L=L1L+1
      endif
C
   17 LL=LL+I+1
C
C
         ENTRY MXEQU1  (A,B,I,J)
C
C--                TRANSFORMATION OF B-MATRIX
   20 IF (I*J.EQ.0) RETURN
C
      ML=1
         DO 26 L=1,I
C
         DO 26 M=1,J
      MN=M
      LN=L
C
         DO 25 N=1,I
      IF (L.EQ.N) GO TO 24
      B(MN)=B(MN)+B(ML)*A(LN)
   24 MN=MN+J
   25 LN=LN+I
C
   26 ML=ML+1
C
C--                PUTS FINAL RESULT IN B-MATRIX
      NN=1
      MN=1
         DO 36 N=1,I
      DIAG=1./A(NN)
C
         DO 35 M=1,J
      B(MN)=B(MN)*DIAG
   35 MN=MN+1
C
   36 NN=NN+I+1
C
      RETURN
      END
