
      function mtbin(lun,job)   ! stub for PC
      mtbin=mdbin(lun,job)
      return
      end

      function mtdbin(lun,job)    ! Read from tape if lun>0  else from disk
      if(lun.lt.0) mtdbin=mdbin(-lun,job)
      if(lun.ge.0) mtdbin=mtbin(lun,job)
      return
      end

      function mtcdc(lun,buf)
      integer*4 i8                    ! integer*8 will be better !
      real*8 buf(2)
C---
      j=mtdbin(lun,1)                 ! Read current record
      mtcdc=0
      if(j.eq.0) return               ! eof
      if(lun.gt.0) call u60t64(0)     ! overpack if read from tape
      k=0
  1   k=k+1
      call numcdc(k,i8,buf(k),i)      ! buf = CDC record
      if(i.ge.0) goto 1
      k=k-1
      if(j.lt.0) k=-k                 ! if read errors
      mtcdc=k                         ! record length
      return
      end

      subroutine U60T64(iwrite) ! Unpack 60-bits CDC tape record after MTBIN
C*
C***  Performs unpacking a record, just read by MTBIN,
C*    into more convinient representation, where each 60-bit CDC-word
C*    is represented as 2 32-bit words:
C*     1 : 60-33 bits of CDC-word in 28-1 bits (bits 32-29 are zero)
C*     2 : 32-1  bits of CDC-word
C*    That's all  if IWRITE=0, unpacked record stays in the same place.
C*
C*    If IWRITE <> 0, iabs(iwrite) will be treated as logical unit number,
C*    where unpacked record must be written.  Corresponding file will be
C*    named  TAPE.CDC and opened as a direct access file with RECL=8 bytes.
C*    (U60T64 does it automatically during the first CALL).
C*    If tape record contains N words CDC, it will be written as N+1 record,
C*    where 1-st record will contain a header:
C*       bytes 1-4 : N as integer*4
C*       bytes 5-8 : 0 if record was read without parity error, else 1.
C*    If tape record is EOF, only empty header (8 zero bytes) will be written.
C*    If you intend to process TAPE.CDC on VAX, put IWRITE > 0
C*    If it will be ported on computer with direct byte numeration,
C*    IWRITE must be < 0.
C*
C*    When finishing tape read, you MUST   CALL U60FIN(iwrite) to close file
C*    -----------------------------------------------------------------------
C*
C*    If CDC-words were additionally packed in a record through routine
C*    like well known "PACK2" (60 bit into 30, 2 words into 1), main program
C*    must set nonzero data   in COMMON /PFACT/ LMANT
C*    LMANT=<length of packed mantissa>   ( 18,19,...,24 )
C*    -----------------------------------------------------------------------
C*
      common /tape_info/ mttype
      integer*4 mttype                 ! >0 if reading from real tape
      common /pfact/     lmant
      integer*4          lmant
      common /cmtbin/    iprint,       ! Trace flag
     *                   len,          ! current record length (bytes)
     *                   mer,          ! reading error flag
     *                   buf           ! internal buffer for reading
C      byte buf,buf2(10000),hbytes(16)
      integer*4 buf(5000),buf2(2500),hbytes(16)  ! PC

      integer*4 ibuf(2),iprint,len,mer,lun,i,j,k,nrec,nwcdc
      equivalence(buf2(1),buf(10001)),(ibuf(1),len)
      data nrec/0/, lmant/0/, mttype/-1/
C---
      if(mttype.lt.0) return           ! if reading from Disk
      do i=1,len
        buf2(len+1-i) = buf(len+1-i)   ! move all record up
      enddo
      nwcdc = (8*len)/60
      i60=1
      j4=-4
      i32=3                        ! buf(1)
      hbytes(1)=0
      do i=1,nwcdc
        do j=2,16                  ! halfbytes: 15*4 = 60
          k=buf2(i60)
          k=iand(15,ishft(k,j4))
          hbytes(j)=k
          j4=ieor(j4,-4)
          if(j4.ne.0) i60=i60+1
        enddo
        ibuf(i32)=0
        do j=1,16                  ! join halfbytes into integer*4
          k=hbytes(j)
          ibuf(i32)=ior(k,ishft(ibuf(i32),4))
          if( mod(j,8).eq.0 ) i32=i32+1
        enddo
        if(lmant.ne.0) then
          ibuf(i32-2)=ior(ishft(ibuf(i32-2),2),ishft(ibuf(i32-1),-30))
          ibuf(i32)=ishft(ishft(ibuf(i32-1),2),-2)
          call upak2(ibuf(i32-2),lmant)
          call upak2(ibuf(i32),lmant)
          i32=i32+2
        endif
      enddo                        ! all CDC-words
      if(lmant.ne.0) nwcdc=2*nwcdc
      len = nwcdc                  ! we may now forget about bytes
      lun = iabs(iwrite)
      if(lun.ne.0) then
        if(nrec.eq.0)  open( lun,
     -       file='TAPE.CDC',access='direct',recl=8,status='UNKNOWN')
        do i=1,nwcdc+1
            j = ibuf(2*i-1)
            k = ibuf(2*i)    ! VAX bytes order
            if(iwrite.lt.0) then
              j = invert(j)  ! direct bytes order
              k = invert(k)
            endif
            nrec=nrec+1
            write(lun,rec=nrec) j,k
        enddo
        if(iprint.ne.0) write(*,*) ' U60T64:',nwcdc,
     -      ' CDC-words and header are written to file TAPE.CDC'
      endif
      return
C
      entry U60FIN(iwrite)          ! For transfer finishing
      lun=iabs(iwrite)
      j=0
      nrec=nrec+1
      write(lun,rec=nrec) j,j       ! Last EOF
      close(lun)
      if(iprint.ne.0) write(*,*) ' U60FIN:',nrec,' records ',
     -   '(8 bytes each) are written to file TAPE.CDC'
      return
      end

      function MDBIN(lun,job)  ! Instead of MTBIN+U60T64 if readind from disk
      common /cmtbin/    iprint,       ! Trace flag
     *                   len,          ! current record length (words CDC)
     *                   mer,          ! error flag
     *                   ibuf(2,2500)  ! internal buffer
      integer*4 iprint,len,mer,ibuf,nrec,invert
      character*1 cc
      data nrec/-1/
C
      if(lun.eq.0) then
        iprint=job
        mdbin=0
        return
      endif
      if(nrec.lt.0) then
        open( lun,file='tape.cdc',access='direct',recl=8,status='OLD')
        nrec=0
      endif
      if(job.eq.0) then
        nrec=0
        mdbin=0
        return
      endif
      nrec=nrec+1
      read(lun,rec=nrec,err=999) len,mer
      indean=ishft(len,-16)
      cc=':'
      if(indean.ne.0) then
        len=invert(len)
        cc='>'
      endif
      if(len.eq.0) goto 999
      do i=1,len
        nrec=nrec+1
        read(lun,rec=nrec,err=999) ibuf(1,i),ibuf(2,i)
        if(indean.ne.0) then
           ibuf(1,i)=invert(ibuf(1,i))
           ibuf(2,i)=invert(ibuf(2,i))
        endif
      enddo
      if(iprint.ne.0) write(*,'(7h MDBIN(,i2,1h),a1,i6,11h words read)')
     -                        lun,cc,len
      mdbin = len
      if(mer.ne.0) mdbin=-len
      return
 999  if(iprint.ne.0) write(*,*) ' MDBIN: End of file'
      mdbin=0
      return
      end

      function INVERT( n )  ! inverse bytes in VAX-integer
      integer*4 n,k,j
        k=0
        j=n
        do i=1,4
          k=ior( ishft(k,8), iand(255,j) )
          j=ishft(j,-8)
        enddo
        invert = k
        return
      end

      subroutine upak2(w,m)         ! unpack 30-bit CDC to 60
      integer*4 w(2),m
      w(2)=ishft(w(1),32-m)         ! mantissa left adjusted
      js=ishft(w(1),-29)            ! 30 bit = sign
      jb=ishft(w(1),-28)            ! 29 bit = bias
      if(jb.eq.0) then
        w(1)=0
        w(2)=0
        return
      endif
      w(1)=ishft(ishft(w(1),4),-m-4)    ! exponent in low bits
      w(1)=w(1)-47                  ! 47 was added by PACK2
      if(w(1).ge.0) then
        w(1)=w(1)+1024              ! positive exponent
       else
        w(1)=w(1)-1
        w(1)=iand(w(1),1023)        ! negative exponent
      endif
      w(1)=ior(ishft(w(1),16),ishft(w(2),-16))
      w(2)=ishft(w(2),16)           ! our standard representation
      if(js.ne.0) then
        w(2)=not(w(2))              ! negative number
        w(1)=ishft(ishft(not(w(1)),4),-4)
      endif
      return
      end

      subroutine NUMCDC(K,IN,RN,IR) ! convert numbers from CDC representation
      implicit real*8(A-H,O-Z)
      parameter(MAXEXP=300)         ! max value of exponent  (120 for VAX)
      parameter(LINT=32)            ! length of integer      ( 32 for VAX)
      parameter(ME2=2*MAXEXP+1)
      integer*4 k,ir
      integer*4 in,icode            ! integer*8 will be better !
C*
C***  NUMCDC gets K-th CDC-number from record,
C*           processed by U60T64 or read by MDBIN.
C*         K=1,2,...,<length of record>         (input parameter)
C*         IN,RN,IR - output parameters, their values are calculated by NUMCDC:
C*            IR = type of number:
C*        -1: record is finished    ( IN=0, RN=0 )
C*         0: invalid number        ( written to both IN and RN )
C*         1: extracted an integer  ( written to IN, RN=float(IN) )
C*         2: extracted a  real     ( written to RN, IN=int(RN)   )
C*
      common /cmtbin/    iprint,       ! no used
     *                   len,          ! current record length (words CDC)
     *                   mer,          ! no used
     *                   ibuf(2,2500)  ! internal buffer after U60T64
      integer*4 iprint,len,mer,ibuf,w28,w32,m(3)
      real*8 e(ME2)
      data e/ME2*0.0/
C----------------------------------
      ir = -1
      in = 0
      rn = 0.0
      if(k.gt.len) return
      w28 = ibuf(1,k)
      w32 = ibuf(2,k)
      icode = w28
      icode = ior(w32, ishft(icode,32))
      if(e(MAXEXP+1).eq.0.0) then
        e(MAXEXP+1)=1.0                   ! preparing list of 2**n
        do i=1,maxexp
          e(i+MAXEXP+1)=2.0*e(i+MAXEXP)
          e(MAXEXP+1-i)=0.5*e(MAXEXP+2-i)
        enddo
      endif
c------------------------------------------------------------------------
      nsig=iand(1,ishft(w28,-27))
      if(nsig.ne.0) then          ! negative
          w32 = not(w32)
          w28 = ishft(ishft(not(w28),4),-4)
      endif
      nexp=ishft(w28,-16)
      if(nexp.eq.0) then          ! integer CDC
        ir = 1
        if(LINT.gt.32) then
            in1=ior(w32,ishft(w28,32))
          else
            in1=w32
            if(w28.ne.0) ir=0     ! too big
        endif
        if(nsig.ne.0) in1=-in1
        RN = in1
        IN = in1
      else                        ! float CDC
        ir=2
        rn1 = 0.0
        nexp=nexp-1024
        if(nexp.lt.0) nexp=nexp+1
        if(iabs(nexp+48).lt.maxexp) then          ! ok exponent
            m(1)=ishft(ishft(w28,16),-16)
            m(2)=ishft(w32,-16)
            m(3)=ishft(ishft(w32,16),-16)
            do i=1,3
              rn1=65536.0*rn1+m(i)   ! mantissa
            enddo
            rn1=rn1*e(nexp+MAXEXP+1) ! set exponent
            if(nsig.ne.0) rn1=-rn1
          else
            if(nexp.gt.0) ir=0       ! RN=0 if exponent is too small
        endif
        if(abs(rn1).lt.1.0d18) IN = rn1
        RN = rn1
      endif
C-----------------------------------------------------------------------
      if(ir.eq.0) then
        if(iprint.ne.0) write(*,*) ' NUMCDC(',k,' ) : too big number !'
        in=icode
        rn=in
      endif
      return
      end

      subroutine C10CDC(K,C,W28,W32,IR) ! Convert text from CDC representation
      integer*4 k,w28,w32,ir
      character*10 c
C*
C***  C10CDC gets K-th CDC-word (60 bits) from record, processed by U60T64.
C*         K=1,2,...,<length of record>      - input parameter
C*         C,W28,W32,IR  - output parameters, are filled by C10CDC.
C*         IR=-1 : record is finished    ( C,W28,W32  undefined )
C*         IR=<counter of characters, extracted from K-th word CDC>
C*            as usual, IR=10
C*         C   : character string, containing these characters (length=10)
C*         W28 : High 28 bits of extracted CDC-word (60-33)
C*         W32 : Low  32 bits of extracted CDC-word (32-1)
C*
      common /cmtbin/    iprint,       ! no used
     *                   len,          ! current record length (words CDC)
     *                   mer,          ! no used
     *                   ibuf(2,2500)  ! internal buffer after U60T64
      integer*4 iprint,len,mer,ibuf,m(10)
      character*64 t
      character*1 c1
      data t/
     *'@ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789+-*/()$= ,.@[]%#@~|@@<>@@!;'
     *      /
C--------------------------------------------------
      ir = -1
      if(k.gt.len) return
      w28 = ibuf(1,k)
      w32 = ibuf(2,k)
      m(1)=iand( 63, ishft(w28,-22) )
      m(2)=iand( 63, ishft(w28,-16) )
      m(3)=iand( 63, ishft(w28,-10) )
      m(4)=iand( 63, ishft(w28,-4 ) )
      m(5)=iand( 63, ishft(w28,2  ) )
      m(5)=ior( m(5), ishft(w32,-30) )
      m(6)=iand( 63, ishft(w32,-24) )
      m(7)=iand( 63, ishft(w32,-18) )
      m(8)=iand( 63, ishft(w32,-12) )
      m(9)=iand( 63, ishft(w32,-6) )
      m(10)=iand( 63, w32 )
      ir=0
      do i=1,10
        j=m(i)+1
        c1=t(j:j)
        if(c1.ne.'@') ir=ir+1
        c(i:i)=c1
      enddo
      return
      end

      subroutine wrtxt(lun)
      common/cmtbin/iprint,len,mer,buf
      integer*4 iprint,len,mer
C      byte buf(20000)
      integer*4 buf(5000) ! for PC only

      character*80 line
      character*1 ebciso
      data nc/0/
      if(lun.le.0) return
      if(nc.eq.0) open(lun,file='TAPE.CDC',status='unknown')
      k=0
      do i=1,len
        line(k+1:k+1) = ebciso(char(buf(i)))
        k=k+1
        if(k.eq.80.or.i.eq.len) then
          nc=nc+1
          j=81
  1       j=j-1
          if(j.gt.1.and.line(j:j).eq.' ') goto 1
          write(lun,'(80A1)') (line(k:k),k=1,j)
          k=0
        endif
      enddo
      if(iprint.ne.0) write(*,*) nc,' lines are written on TAPE.CDC'
      return
      end

      subroutine wrcnt(lun)
      common/cmtbin/iprint,len,mer,buf
      integer*4 iprint,len,mer,cnt4
      integer*4 cnt,keof       ! integer*8 will be better
      real*8 buft(1000)
C      byte buf(20000)
      integer*4 buf(5000)      ! for PC only !

      data nc/-1/, keof/0/
      call u60t64(0)
      if(lun.le.0) return
      k = 2          ! Each block contains 2 auxiliary words
      if(nc.lt.0) open(lun,file='TAPE.CDC',status='unknown',
     *                     form='UNFORMATTED')
      nc=0
      if(len.eq.0) then
        write(*,*) keof,' - length record is written on TAPE.CDC'
        write(lun) keof,keof
        return
      endif
  1   k=k+1
      call numcdc(k,cnt,buft,j)       ! get counter
      if(j.ne.1.or.cnt.eq.0) goto 2   ! 0 - end of inform in this block
      cnt4 = cnt
      do i=1,cnt4
             k=k+1
             call numcdc(k,cnt,buft(i),j)
      enddo
      cnt=cnt4
      write(lun) cnt,(buft(i),i=1,cnt4)
      nc=nc+1
      goto 1
   2  if(iprint.ne.0) write(*,*) nc,' records are written on TAPE.CDC'
      return
      end

      subroutine ebcdic(k,j)
      common/cmtbin/iprint,len,mer,buf
      integer*4 iprint,len,mer,b4(2)
      character*80 text,buf
      equivalence(b4,buf)
      character*1 ebciso
      j=-1
      text='          '
      if(80*k.gt.len) return
      j=3
      do i=1,80
        j=80*k-80+i
        text(i:i)=ebciso(buf(j:j))
      enddo
      if(iprint.ne.0)  write(*,*) text(1:79)
      return
      end

      character*1 function ebciso(c)
      character*1 c
       character*16 e(16)
      character*256 t
      equivalence(t,e(1))
C...............0123456789ABCDEF...........
      data e/ 16h~~~~~~~~~~~~~~~~,
     1        16h~~~~~~~~~~~~~~~~,
     2        16h~~~~~~~~~~~~~~~~,
     3        16h~~~~~~~~~~~~~~~~,
     4        16h ~~~~~~~~~#.<(+|,
     5        16h&~~~~~~~~~!$*);^,
     6        16h-/~~~~~~~~~,%_>?,
     7        16h~~~~~~~~~~:#@'=",
     8        16h~abcdefghi~~~~~~,
     9        16h~jklmnopqr~~~~~~,
     A        16h~~stuvwxyz~~~~~~,
     B        16h~~~~~~~~~~~~~~~~,
     C        16h~ABCDEFGHI~~~~~~,
     D        16h~JKLMNOPQR~~~~~~,
     E        16h~~STUVWXYZ~~~~~~,
     F        16h0123456789~~~~~~  /
C------------------------------------
       ic = ichar(c) + 1
       ebciso = t(ic:ic)
       return
       end

      subroutine ctlook  ! Main program for looking and copying CDC tape
      common /pfact/ lmant
      character*10 text,answ
      character*7 notes(3)
      integer*4 lun,lmant,in1,in2,mpr,nfcnt
      integer*4 intcdc        ! integer*8 will be better !
      real*8 rcdc
C*      lun < 0  if reading from file "TAPE.CDC"
      data lunc/22/, lun/-1/
      data notes/'invalid','integer','real'/
C-----------
      write(*,*) '  CTLOOK - CDC tape looking and copying.'
      if(lun.ge.0) then
        write(*,'(25h reading from tape(Y/N):   ,$)')
        read(*,'(a1)') answ
        if(answ(1:1).eq.'N'.or.answ(1:1).eq.'n') lun=-1
      endif
      if(lun.eq.lunc) lunc=lunc+1
      i=mdbin(0,1)             ! Tracing on
      mpr=1
      nfc=1000
      nrc=100000000
  1   if(lun.gt.0) then
        write(*,'(21h Rewind tape (Y/N) :   ,$)')
        read(*,'(a1)') answ
        if(answ(1:1).eq.'Y'.or.answ(1:1).eq.'y')
     -                   i=mtdbin(lun,0)           ! Rewind
      endif
      write(*,'( 17h Files to skip : ,$ )')
      read(*,*) nfs
C      write(*,'(25h eof assumed if reclen < ,$ )')
C      read(*,*) j
C      j=mdbin(0,-max(1,j))    ! set EOF criteria
      if(nfs.gt.0) then
        do i=1,nfs
  2       if(mtdbin(lun,1).ne.0) goto 2
        enddo
      endif
      write(*,'( 16h Records in file,i3,11h to skip : ,$ )') nfs+1
      read(*,*) nrs
      if(nrs.gt.0) then
        do i=1,nrs
          if(mtdbin(lun,1).eq.0) then
            write(*,*) ' EOF while skipping records. Let us repeat!'
            goto 1
          endif
        enddo
      endif
      if(lun.gt.0) then        ! Reading from real tape
      write(*,'(46h Tape format:  1 - binary,  2 - packed binary,)')
      write(*,'(46h               3 - blocked, 4 - EBCDIC text ? ,$ )')
         read(*,*) ntform
         if(ntform.eq.2) then
              write(*,'( 25h mantis length (17:25) : ,$ )')
              read(*,*) lmant
         endif
      write(*,'( 31h Copy to file TAPE.CDC (y/n) : ,$ )')
      read(*,'(a1)') answ(1:1)
      if(answ(1:1).ne.'Y' .and. answ(1:1).ne.'y') lunc=0  ! Block copying
      if(lunc.ne.0) then
        write(*,'( 26h How many files to copy : ,$ )')
        read(*,*) nfc
        if(nfc.lt.1) nfc=1
        if(nfc.eq.1) then
          write(*,'( 28h How many records to copy : ,$ )')
          read(*,*) nrc
          if(nrc.lt.1) nrc=100000000
        endif
        write(*,'( 19h   silently(y/n) : ,$ )')
        read(*,'(a1)') answ(1:1)
        if(answ(1:1).eq.'Y' .or. answ(1:1).eq.'y') mpr=0
        i=mdbin(0,mpr)                 ! Trace mode
      endif
      else           !  Reading from disk
        lmant=0
        lunc=0
        ntform=1
      endif
      nfcnt=0
      minlen=999999
      do i=1,nrc
 88     j=mtdbin(lun,1)
        if(iabs(j).gt.minlen) goto 88           ! skip until given length
        minlen=999999
        if(j.eq.0) write(*,*) nfcnt+1,' EOF is reached on source tape.'
        if(ntform.eq.1.or.ntform.eq.2) call u60t64(lunc)
        if(ntform.eq.3) call wrcnt(lunc)
        if(ntform.eq.4) call wrtxt(lunc)
      if(j.eq.0) then
        nfcnt=nfcnt+1
        if(nfcnt.ge.nfc) goto 9
      endif
      if(mpr.ne.0) then
        k=0
        if(ntform.lt.4.and.j.ne.0)
     -   write(*,*) ' NCDC:        HEX1,HEX2       TEXT     INTEGER',
     -             '         REAL         note'
   3    k=k+1
        if(ntform.eq.4)       call ebcdic(k,j)
        if(ntform.lt.4)  then
          call c10cdc(k,text,in1,in2,j)
          if(j.ge.0) then
            call numcdc(k,intcdc,rcdc,j)
            write(*,'(i6,2h: ,2z8,1x,a10,i12,e20.12,1x,a7)')
     -       k,in1,in2,text,intcdc,rcdc,notes(j+1)
          endif
        endif
        if(j.lt.0) k=0
        if(mod(k,20).ne.0) goto 3          ! Paging
          write(*,'(20x,44hQuit/Nextrec/Back/nextFile/Until/Continue : ,
     *            $ )')
          read(*,'(a1)') answ(1:1)
          if((answ(1:1).eq.'S' .or. answ(1:1).eq.'s').and.lunc.ne.0)
     -      mpr = 0                          ! Copy in silent mode
          if(answ(1:1).eq.'Q' .or. answ(1:1).eq.'q') goto 9
          if(answ(1:1).eq.'U'.or.answ(1:1).eq.'u') then
              write(*,'(20x,20hskip until length <  ,$ )')
              read(*,*) minlen
              answ(1:1)='F'
              j=mdbin(0,-max(1,minlen))      ! Set new EOF criteria
          endif
          if(answ(1:1).eq.'F' .or. answ(1:1).eq.'f') then
  8           if(mtdbin(lun,1).ne.0) goto 8
              answ(1:1)='N'
          endif
          if(answ(1:1).eq.'B' .or. answ(1:1).eq.'b') then
              j=mtdbin(lun,-1)
              j=mtdbin(lun,-1)
              answ(1:1)='N'
          endif
          if(k.ne.0.and.answ(1:1).ne.'N' .and. answ(1:1).ne.'n') goto 3
      endif            ! mpr.ne.0
      enddo            ! records loop
  9   i=mdbin(0,1)
      if(lunc.ne.0) then
        if(ntform.eq.1.or.ntform.eq.2) call U60FIN(lunc)
      endif
      write(*,*) ' Bye.'
      end

