      program tap
      call ctlook
      end

      function MTBIN ( LUN,JOB )      ! compile:  for/ext mtbin
      parameter(MAXLUN=16)
C*
C***    Set of operations with foreign TAPES (VAX computer)
C*      ---------------------------------------------------
C*   LUN: logical unit number = 1,2,...,MAXLUN (here 16)
C*        corresponding logical names are: MT01,MT02,...,MT16
C*        Before running program all needed tapes must be mounted.
C*        For example, if you intend to use volume 94557 as unit 6
C*        and mount it on device msc0,  execute command
C*   MOUNT/for/nounload/comm="Tape 94557 noring Dens=1600" msc0: 94997 mt06:
C*        after each your session starting.
C*        Tape will be assigned automatically during a 1-st call MTBIN.
C*        To get device free after finishing your last session, don't forget
C*        execute command  DISM/unload  msc0:
C*
C*   JOB: opcode (0:rewind, -1:backspace, 1-read physical record, ... )
C*     Rewind (JOB=0)  sets a tape before the 1-st record. If tape is
C*        labelled (first 1 or 2 records are short, less than 100 bytes),
C*        then label and its EOF will be skipped automatically.
C*        An initial REWIND is performed automatically while assigning tape,
C*        so you may start tape processing just with reading.
C*        Result (value of MTBIN) is always 0.
C*
C*     READ PHYSICAL RECORD (JOB=1) reads all bytes of current record in
C*        the internal buffer BUF (see common/cmtbin/...).
C*        Value of MTBIN is:
C*        0    - EOF is read, tape is staying after it;
C*        N>0  - no errors, N bytes were read;
C*        N<0  - there was a parity error, IABS(N) bytes were read;
C*
C*    As for backspace and write: I don't know yet how to do them!
C*    --------------------------------------------------------------
C*    MTBIN(0,1) turns exchange tracing ON
C*    MTBIN(0,0) turns exchange tracing OFF (default)
C*    --------------------------------------------------------------

      common /tape_info/ lunc,         ! current LUN
     *                   nbl(MAXLUN),  ! record counters (including EOFs)
     *                   chan(MAXLUN)  ! system idents
      common /cmtbin/    iprint,       ! Tracing exchanges flag if=1
     *                   len,          ! current record length (bytes)
     *                   mer,          ! reading error flag
     *                   buf(65535)    ! internal buffer for reading
      byte buf                         ! (common for all tapes!)
      integer*4 iprint,len,mer

      external io$_rewind, io$_readvblk,io$m_datacheck        
      include '($ssdef)'
      integer*4 lunc,nbl,chan,status,sys$assign,sys$qiow
      integer*2 func1,func2,code,iosb(4)
      character*4 unit
      character*8 mess
      data unit/'MT00'/, iprint/0/, len/0/
      data chan/MAXLUN*0/             ! - tapes are not assigned
C
      mtbin=0
      if(lun.eq.0) then
        iprint=job
        return
      endif
      lunc = lun
      if(lun.lt.1.or.lun.gt.MAXLUN) then
        write(*,*) ' MTBIN: illegal unit',lun
        stop 'MTBIN'
      endif
      if(chan(lun).ne.0) goto 1
      len=lun/10
      code=mod(lun,10)
      unit(4:4)=char(code+ichar('0'))
      unit(3:3)=char(len+ichar('0'))
      status = sys$assign(unit,chan(lun),,,)
      if (status.ne.1) then
C        call lib$signal(%val(status))
        write(*,*) ' MTBIN: tape',lun,' not assigned!'
        stop 'MTBIN'
      endif
c
c rewind a tape in fast reverse mode
c
  7   func1=%loc(io$_rewind)
      if(iprint.ne.0) write(*,*) ' MTBIN: rewind',lun
      status=sys$qiow(,%val(chan(lun)),%val(func1),iosb,,,,,,,,)
      if (status.ne.1) then
C        call lib$signal(%val(status))
        write(*,*) ' MTBIN: error while rewind',lun
        stop 'MTBIN'
      endif
      nbl(lun) = 0
      if(job.eq.0) return      ! only rewind
c------------------------------------------------------------------------
c
  1   if(job.ne.1) goto 100
      func1=%loc(io$_readvblk)
      func2=%loc(io$m_datacheck)
      status=sys$qiow(,%val(chan(lun)),%val(func1+func2),iosb,,,
     -                buf,%val(65535),,,,)
      code = iosb(1) ! compare code with the ss$ macros
      len  = iosb(2) ! length of variable block read (bytes)
      nbl(lun) = nbl(lun)+1
      mess='        '
      mer=0
      if (code.eq.ss$_endoffile) then
        len=0
        mess=' E O F  '
      endif
      if (code.eq.ss$_parity) then
        mer=1
        mess=' ERROR! '
      endif
      mtbin = len                                 ! Result=bytes read
      if(mer.ne.0) mtbin = -len
      if(len.lt.100 .and. nbl(lun).lt.4) mess=' skipped'
      if(iprint.ne.0) write(*,*) ' MTBIN(',lun,' ) : read record',
     -       nbl(lun),len,' bytes ',mess
      if(len.lt.100 .and. nbl(lun).lt.4) goto 1   ! LABEL
      return
C
 100  if(job.eq.0) goto 7                         ! rewind
      write(*,*) ' MTBIN(',lun,' ) : illegal opcode',job
      stop 'MTBIN'
      end

      subroutine U60T64 ( iwrite )   ! After MTBIN on VAX
C*
C***  Performs unpacking a record, just read by MTBIN,
C*    into more convinient representation, where each 60-bit CDC-word
C*    is represented as 2 32-bit words:
C*     1 : 60-33 bits of CDC-word in 28-1 bits (bits 32-29 are zero)
C*     2 : 32-1  bits of CDC-word
C*    That's all  if IWRITE=0, unpacked record stays in the same place.
C*
C*    If IWRITE <> 0, iabs(iwrite) will be treated as logical unit number,
C*    where unpacked record must be written.  Corresponding file will be
C*    named  TAPE.CDC and opened as a direct access file with RECL=8 bytes.
C*    (U60T64 does it automatically during the first CALL).
C*    If tape record contains N words CDC, it will be written as N+1 record,
C*    where 1-st record will contain a header:
C*       bytes 1-4 : N as integer*4
C*       bytes 5-8 : 0 if record was read without parity error, else 1.
C*    If tape record is EOF, only empty header (8 zero bytes) will be written.
C*    If you intend to process TAPE.CDC on VAX, put IWRITE > 0
C*    If it will be ported on computer with direct byte numeration,
C*    IWRITE must be < 0.
C*
C*    When finishing tape read, you MUST   CALL U60FIN(iwrite) to close file
C*    -----------------------------------------------------------------------
C*
C*    If CDC-words were additionally packed in a record through routine
C*    like well known "PACK2" (60 bit into 30, 2 words into 1), main program
C*    must set nonzero data   in COMMON /PFACT/ LMANT
C*    LMANT=<length of packed mantissa>   ( 18,19,...,24 )
C*    -----------------------------------------------------------------------
C*
      common /pfact/     lmant
      integer*4          lmant
      common /cmtbin/    iprint,       ! Trace flag
     *                   len,          ! current record length (bytes)
     *                   mer,          ! reading error flag
     *                   buf(65535)    ! internal buffer for reading
      byte buf,buf2(20000),hbytes(16)
      integer*4 ibuf(2),iprint,len,mer,lun,i,j,k,nrec,nwcdc
      equivalence(buf2(1),buf(20001)),(ibuf(1),len)
      data nrec/0/, lmant/0/
C---
      do i=1,len
        buf2(len+1-i) = buf(len+1-i)   ! move all record up
      enddo
      nwcdc = (8*len)/60
      i60=1
      j4=-4
      i32=3                        ! buf(1)
      hbytes(1)=0
      do i=1,nwcdc
        do j=2,16                  ! halfbytes: 15*4 = 60
          k=buf2(i60)
          k=iand(15,ishft(k,j4))
          hbytes(j)=k
          j4=ieor(j4,-4)
          if(j4.ne.0) i60=i60+1
        enddo
        ibuf(i32)=0
        do j=1,16                  ! join halfbytes into integer*4
          k=hbytes(j)
          ibuf(i32)=ior(k,ishft(ibuf(i32),4))
          if( mod(j,8).eq.0 ) i32=i32+1
        enddo
        if(lmant.ne.0) then
          ibuf(i32-2)=ior(ishft(ibuf(i32-2),2),ishft(ibuf(i32-1),-30))
          ibuf(i32)=ishft(ishft(ibuf(i32-1),2),-2)
          call upak2(ibuf(i32-2),lmant)
          call upak2(ibuf(i32),lmant)
          i32=i32+2
        endif
      enddo                        ! all CDC-words
      if(lmant.ne.0) nwcdc=2*nwcdc
      len = nwcdc                  ! we may now forget about bytes
      lun = iabs(iwrite)
      if(lun.ne.0) then
        if(nrec.eq.0)  open( lun,
     -       file='TAPE.CDC',access='direct',recl=2,status='NEW')
        do i=1,nwcdc+1
            j = ibuf(2*i-1)
            k = ibuf(2*i)    ! VAX bytes order
            if(iwrite.lt.0) then
              j = invert(j)  ! direct bytes order
              k = invert(k)
            endif
            nrec=nrec+1
            write(lun,rec=nrec) j,k
        enddo
        if(iprint.ne.0) write(*,*) ' U60T64:',nwcdc,
     -      ' CDC-words and header are written to file TAPE.CDC'
      endif
      return
C
      entry U60FIN(iwrite)          ! For transfer finishing
      lun=iabs(iwrite)
      j=0
      nrec=nrec+1
      write(lun,rec=nrec) j,j       ! Last EOF
      close(lun)
      if(iprint.ne.0) write(*,*) ' U60FIN:',nrec,' records ',
     -   '(8 bytes each) are written to file TAPE.CDC'
      return
      end

      subroutine upak2(w,m)         ! unpack 30-bit CDC to 60
      integer*4 w(2),m
      w(2)=ishft(w(1),32-m)         ! mantissa left adjusted
      js=ishft(w(1),-29)            ! 30 bit = sign
      jb=ishft(w(1),-28)            ! 29 bit = bias
      if(jb.eq.0) then
        w(1)=0
        w(2)=0
        return
      endif
      w(1)=ishft(ishft(w(1),4),-m-4)    ! exponent in low bits
      w(1)=w(1)-47                  ! 47 was added by PACK2
      if(w(1).ge.0) then
        w(1)=w(1)+1024              ! positive exponent
       else
        w(1)=w(1)-1
        w(1)=iand(w(1),1023)        ! negative exponent
      endif
      w(1)=ior(ishft(w(1),16),ishft(w(2),-16))
      w(2)=ishft(w(2),16)           ! our standard representation
      if(js.ne.0) then
        w(2)=not(w(2))              ! negative number
        w(1)=ishft(ishft(not(w(1)),4),-4)
      endif
      return
      end

      subroutine ctlook  ! Main program for looking and copying CDC tape
      common /pfact/ lmant
      character*10 text,answ
      character*7 notes(3)
      integer*4 lmant,in1,in2,intcdc,mpr,nfcnt
      real*8 rcdc
      data lun/6/, lunc/22/
      data notes/'invalid','integer','real'/
C-----------
      write(*,*) ' CDC tape looking and copying.'
      write(*,'( 24h Enter logical number : ,$ )')
      read(*,*) lun
      i=mtbin(0,1)             ! Tracing on
      mpr=1
      nfc=1000
      nrc=100000
  1   i=mtdbin(lun,0)           ! Rewind
      write(*,'( 14h Skip files : ,$ )')
      read(*,*) nfs
      if(nfs.gt.0) then
        do i=1,nfs
  2       if(mtdbin(lun,1).ne.0) goto 2
        enddo
      endif
      write(*,'( 21h Skip records in file,i3,3h : ,$ )') nfs+1
      read(*,*) nrs
      if(nrs.gt.0) then
        do i=1,nrs
          if(mtdbin(lun,1).eq.0) then
            write(*,*) ' EOF while skipping records. Let us repeat!'
            goto 1
          endif
        enddo
      endif
      if(lun.gt.0) then
      write(*,'( 31h    packed information (y/n) : ,$ )')
      read(*,'(a1)') answ(1:1)
      if(answ(1:1).ne.'Y' .and. answ(1:1).ne.'y') then
         lmant=0
       else
         write(*,'( 25h mantis length (17:25) : ,$ )')
         read(*,*) lmant
      endif
      write(*,'( 31h copy to file TAPE.CDC (y/n) : ,$ )')
      read(*,'(a1)') answ(1:1)
      if(answ(1:1).ne.'Y' .and. answ(1:1).ne.'y') lunc=0  ! Block copying
      if(lunc.ne.0) then
C        write(*,'( 41h are you intend to use it on VAX (y/n) : ,$ )')
C        read(*,'(a1)') answ(1:1)
C        if(answ(1:1).ne.'Y' .and. answ(1:1).ne.'y') lunc=-lunc
        write(*,'( 26h How many files to copy : ,$ )')
        read(*,*) nfc
        if(nfc.eq.1) then
          write(*,'( 28h How many records to copy : ,$ )')
          read(*,*) nrc
        endif
        write(*,'( 19h   silently(y/n) : ,$ )')
        read(*,'(a1)') answ(1:1)
        if(answ(1:1).eq.'Y' .or. answ(1:1).eq.'y') mpr=0
        i=mtbin(0,mpr)                 ! Trace mode
      endif
      else           !  Reading from disk
        lmant=0
         lunc=0
      endif
      nfcnt=0
      do i=1,nrc
        j=mtdbin(lun,1)
        if(lun.gt.0) call u60t64(lunc)
      if(j.eq.0) then
        nfcnt=nfcnt+1
        if(nfcnt.ge.nfc) goto 9
      endif
      if(mpr.ne.0) then
        k=0
        write(*,*) ' NCDC:        HEX1,HEX2       TEXT     INTEGER',
     -             '         REAL         note'
   3    k=k+1
        call c10cdc(k,text,in1,in2,j)
        if(j.ge.0) then
          call numcdc(k,intcdc,rcdc,j)
          write(*,'(i6,2h: ,2z8,1x,a10,i12,e20.12,1x,a7)')
     -       k,in1,in2,text,intcdc,rcdc,notes(j+1)
          if(mod(k,16).ne.0) goto 3          ! Paging
          write(*,'(40x,24hQuit/Nextrec/Continue : ,$ )')
          read(*,'(a1)') answ(1:1)
          if((answ(1:1).eq.'S' .or. answ(1:1).eq.'s').and.lunc.ne.0)
     -      mpr = 0                          ! Copy in silent mode
          if(answ(1:1).eq.'Q' .or. answ(1:1).eq.'q') goto 9
          if(answ(1:1).ne.'N' .and. answ(1:1).ne.'n') goto 3
        endif
      endif
      enddo
  9   i=mtbin(0,1)
      if(lunc.ne.0) call U60FIN(lunc)
      write(*,*) ' Bye.'
      return
      end
      subroutine NUMCDC(K,IN,RN,IR) ! convert numbers from CDC representation
      parameter(MAXEXP=120)         ! max value of exponent  (300 for CONVEX)
      parameter(LINT=32)            ! length of integer      ( 64 for CONVEX)
      parameter(ME2=2*MAXEXP+1)
      integer*4 k,ir
      integer*4 IN,in1         ! integer*8 for CONVEX
      real*8 RN,rn1            ! always real*8 to not loss mantiss
C*
C***  NUMCDC gets K-th CDC-number from record,
C*           processed by U60T64 or read by MDBIN.
C*         K=1,2,...,<length of record>         (input parameter)
C*         IN,RN,IR - output parameters, their values are calculated by NUMCDC:
C*            IR = type of number:
C*        -1: record is finished    ( IN=0, RN=0 )
C*         0: invalid number        ( IN=0, RN=0 )
C*         1: extracted an integer  ( written to IN, RN=float(IN) )
C*         2: extracted a  real     ( written to RN, IN=int(RN)   )
C*
      common /cmtbin/    iprint,       ! no used
     *                   len,          ! current record length (words CDC)
     *                   mer,          ! no used
     *                   ibuf(2,1000)  ! internal buffer after U60T64
      integer*4 iprint,len,mer,ibuf,w28,w32,m(3)
      real*8 e(ME2)
      data e/ME2*0.0/
C----------------------------------
      ir = -1
      in = 0
      rn = 0.0
      if(k.gt.len) return
      w28 = ibuf(1,k)
      w32 = ibuf(2,k)
      if(e(MAXEXP+1).eq.0.0) then
        e(MAXEXP+1)=1.0                   ! preparing list of 2**n
        do i=1,maxexp
          e(i+MAXEXP+1)=2.0*e(i+MAXEXP)
          e(MAXEXP+1-i)=0.5*e(MAXEXP+2-i)
        enddo
      endif
c------------------------------------------------------------------------
      nsig=iand(1,ishft(w28,-27))
      if(nsig.ne.0) then          ! negative
          w32 = not(w32)
          w28 = ishft(ishft(not(w28),4),-4)
      endif
      nexp=ishft(w28,-16)
      if(nexp.eq.0) then          ! integer CDC
        ir = 1
        if(LINT.gt.32) then
            in1=ior(w32,ishft(w28,32))
          else
            in1=w32
            if(w28.ne.0) ir=0     ! too big
        endif
        if(nsig.ne.0) in1=-in1
        RN = in1
        IN = in1
      else                        ! float CDC
        ir=2
        rn1 = 0.0
        nexp=nexp-1024
        if(nexp.lt.0) nexp=nexp+1
        if(iabs(nexp+48).lt.maxexp) then          ! ok exponent
            m(1)=ishft(ishft(w28,16),-16)
            m(2)=ishft(w32,-16)
            m(3)=ishft(ishft(w32,16),-16)
            do i=1,3
              rn1=65536.0*rn1+m(i)   ! mantissa
            enddo
            rn1=rn1*e(nexp+MAXEXP+1) ! set exponent
            if(nsig.ne.0) rn1=-rn1
          else
            if(nexp.gt.0) ir=0       ! RN=0 if exponent is too small
        endif
        if(abs(rn1).lt.1.E8) IN = rn1
        RN = rn1
      endif
C-----------------------------------------------------------------------
      if(ir.eq.0 .and. iprint.ne.0) write(*,*) ' NUMCDC(',k,' ) : ',
     -     'too big number !'
      return
      end

      subroutine C10CDC(K,C,W28,W32,IR) ! Convert text from CDC representation
      integer*4 k,w28,w32,ir
      character*10 c
C*
C***  C10CDC gets K-th CDC-word (60 bits) from record, processed by U60T64.
C*         K=1,2,...,<length of record>      - input parameter
C*         C,W28,W32,IR  - output parameters, are filled by C10CDC.
C*         IR=-1 : record is finished    ( C,W28,W32  undefined )
C*         IR=<counter of characters, extracted from K-th word CDC>
C*            as usual, IR=10
C*         C   : character string, containing these characters (length=10)
C*         W28 : High 28 bits of extracted CDC-word (60-33)
C*         W32 : Low  32 bits of extracted CDC-word (32-1)
C*
      common /cmtbin/    iprint,       ! no used
     *                   len,          ! current record length (words CDC)
     *                   mer,          ! no used
     *                   ibuf(2,1000)  ! internal buffer after U60T64
      integer*4 iprint,len,mer,ibuf,m(10)
      character*64 t
      character*1 c1
      data t/
     *'@ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789+-*/()$= ,.@[]%#@~|@@<>@@!;'
     *      /
C--------------------------------------------------
      ir = -1
      if(k.gt.len) return
      w28 = ibuf(1,k)
      w32 = ibuf(2,k)
      m(1)=iand( 63, ishft(w28,-22) )
      m(2)=iand( 63, ishft(w28,-16) )
      m(3)=iand( 63, ishft(w28,-10) )
      m(4)=iand( 63, ishft(w28,-4 ) )
      m(5)=iand( 63, ishft(w28,2  ) )
      m(5)=ior( m(5), ishft(w32,-30) )
      m(6)=iand( 63, ishft(w32,-24) )
      m(7)=iand( 63, ishft(w32,-18) )
      m(8)=iand( 63, ishft(w32,-12) )
      m(9)=iand( 63, ishft(w32,-6) )
      m(10)=iand( 63, w32 )
      ir=0
      do i=1,10
        j=m(i)+1
        c1=t(j:j)
        if(c1.ne.'@') ir=ir+1
        c(i:i)=c1
      enddo
      return
      end

      function INVERT( n )  ! inverse bytes in VAX-integer
      integer*4 n,k,j
        k=0
        j=n
        do i=1,4
          k=ior( ishft(k,8), iand(255,j) )
          j=ishft(j,-8)
        enddo
        invert = k
        return
      end

      function MTDBIN(lun,job)
      if(lun.lt.0) then
        mtdbin=mdbin( -lun, job )
      else
        mtdbin=mtbin( lun, job )
      endif
      return
      end

      function MDBIN(lun,job)  ! Instead of MTBIN+U60T64 if readind from disk
      integer*4 lun,job
      common /cmtbin/    iprint,       ! Trace flag
     *                   len,          ! current record length (words CDC)
     *                   mer,          ! error flag
     *                   ibuf(2,1000)  ! internal buffer
      integer*4 iprint,len,mer,ibuf,nrec
      data nrec/-1/
C
      if(nrec.lt.0) then
        open( lun,file='TAPE.CDC',access='direct',recl=2,status='OLD')
        nrec=0
      endif
      if(job.eq.0) then
        nrec=0
        mdbin=0
        return
      endif
      nrec=nrec+1
      read(lun,rec=nrec) len,mer
      indean=ishft(len,-16)
      if(indean.ne.0) len=invert(len)
      do i=1,len
        nrec=nrec+1
        read(lun,rec=nrec) ibuf(1,i),ibuf(2,i)
        if(indean.ne.0) then
           ibuf(1,i)=invert(ibuf(1,i))
           ibuf(2,i)=invert(ibuf(2,i))
        endif
      enddo
      if(iprint.ne.0) write(*,*) ' MDBIN:',len,
     -      ' CDC-words are read from file TAPE.CDC'
      mdbin = len
      if(mer.ne.0) mdbin=-len
      return
      end
